### Bibliothèques :
from tkinter import *
from PIL import Image,ImageTk,ImageGrab
from tkinter.messagebox import *
from tkinter.filedialog import *
from tkinter.simpledialog import *
from tkinter.colorchooser import *
from random import randint
### Classes :
class Fenetre:
    def __init__(self,titre="Tk",icone="icone.ico",l=500,h=500,couleur="white"):
        self.fenetre=Tk()
        self.fenetre.title(titre)
        try:
            self.fenetre.iconbitmap(icone)
        except:
            pass
        self.zone_graphique=Canvas(self.fenetre,width=l,height=h,bg=couleur)
        self.zone_graphique.grid(row=0,column=0,columnspan=3)
        self.image=[None,None]
        self.boutons=[]
        self.nom_saisies=[]
        self.saisies=[]
        self.rectangle=None
        self.textes=[]
        self.question=None
        self.reponse=[]
        
    def animation(self,n=0):
        if n==100:
            #self.zone_graphique.create_rectangle(-10,-10,510,510,fill="#FFFFFF",)
            accueil()
        else:
            if n==75:
                self.carre=self.zone_graphique.create_rectangle(-10,-10,510,510,fill=Perso.couleur)
            if n==0:
                self.carre=self.zone_graphique.create_rectangle(-20,-20,520,520,fill=Perso.couleur)
                self.image[0]=ImageTk.PhotoImage(ImageTk.Image.open("logo.png"),master=self.fenetre)
                self.image[1]=self.zone_graphique.create_image(0,0,anchor="nw",image=self.image[0])
            elif n>=70 and n<=74:
                fichier="logo_"+str(n-69)+".png"
                self.image[0]=ImageTk.PhotoImage(ImageTk.Image.open(fichier),master=self.fenetre)
                self.image[1]=self.zone_graphique.create_image(0,0,anchor="nw",image=self.image[0])
            self.fenetre.after(20,lambda:self.animation(n+1))

    def recommencer(self):
        self.image=[None,None]
        self.boutons[-1].destroy()
        del self.boutons[-1]
        self.boutons[-1].destroy()
        del self.boutons[-1]
        self.boutons=[]
        self.nom_saisies=[]
        self.saisies=[]
        self.textes[-1].destroy()
        self.textes=[]
        self.question=None
        self.reponse=[]
        Lrev.fichier=None
        Lrev.liste=[]
        Lrev.titre=""
        Lrev.a_connaitre=1
        Lrev.choix=0
        Lrev.numero=0
        Lrev.point=0
        Lrev.total=0
        accueil(100)


class Fichier:
    def __init__(self):
        self.fichier=None
        self.liste=[]
        self.titre=""
        self.a_connaitre=1
        self.choix=0
        self.numero=0
        self.point=0
        self.total=0
    
    def ouvrir(self):
        lien=askopenfilename(title="Ouvrir une fiche de révision",filetypes=(("Tous les fichiers","*.*"),("Fiche de révision lrev","*.lrev")))
        if lien!="":
            if ".lrev" in lien or ".txt" in lien:
                self.lecture(lien)
            else:
                showerror("Loric Révisions - Erreur", "Impossible d'ouvrir un fichier autre que les fichiers lrev.")
    
    def lecture(self,lien):
        self.fichier=open(lien,"r",encoding='utf-8')
        self.liste=[]
        ligne=self.fichier.readline()
        r="no"
        if "à connaitre" in ligne:
            r=askquestion("Loric Révisions","Voulez-vous charger également les réponses à ne pas savoir ?")
            ligne=ligne.split(",")
            self.titre=ligne[0:-1]
            self.a_connaitre=0
        else:
            ligne=ligne.split(",")
            self.titre=ligne
        ligne=self.fichier.readline()
        while ligne!="":
            if "\n" in ligne:
                ligne=ligne[0:-1]
            ligne=ligne.split(",")
            if (r=="no" and "oui" in ligne) or (r=="yes" and not "?" in ligne) or (self.a_connaitre==1):
                self.liste.append(ligne)
            ligne=self.fichier.readline()
        self.fichier.close()
        self.choix=randint(0,len(self.titre)-1)
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons=[]
        if self.titre[0][0]=="#":
            self.titre[0]=self.titre[0][1:]
            self.choix=0
        F.boutons.append(Button(F.fenetre,text="Commencer",command=Lrev.go))
        F.boutons[-1].place(x=250,y=250,anchor="center")
        
    def go(self):
        F.boutons[-1].destroy()
        del F.boutons[-1]
        for i in range(len(self.titre)):
            if i!=self.choix:
                F.saisies.append(Entry(F.fenetre,textvariable=StringVar()))
                F.saisies[-1].place(x=170,y=150+i*30)
            else:
                F.question=Label(F.fenetre,text="null",bg="white")
                F.question.place(x=170,y=150+i*30)
            F.nom_saisies.append(Label(F.fenetre,text=self.titre[i],bg="white"))
            F.nom_saisies[-1].place(x=70,y=150+i*30)
        F.boutons.append(Button(F.fenetre,text="Valider",command=Lrev.reponse))
        F.boutons[-1].place(x=250,y=350,anchor="center")
        self.question()

            
    def question(self):
        while self.reponse!=[]:
            try:
                F.reponse[-1].destroy()
                del F.reponse[-1]
            except:
                break
        for i in range(len(F.saisies)):
            F.saisies[i].delete(0, END)
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons.append(Button(F.fenetre,text="Valider",command=Lrev.reponse))
        F.boutons[-1].place(x=250,y=350,anchor="center")
        self.numero=randint(0,len(self.liste)-1)
        texte=self.liste[self.numero][self.choix]
        if "/" in texte:
            texte2=texte
            texte=""
            for e in texte2:
                if e=="/":
                    texte+=" ou "
                else:
                    texte+=e
        F.question.configure(text=texte)
        #F.question=Label(F.fenetre,text=texte,bg="white")

    def reponse(self):
        F.reponse=[]
        rep=[]
        j=0
        for i in range(len(self.titre)):
            if i!=self.choix:
                if (F.saisies[i+j].get() == self.liste[self.numero][i] and F.saisies[i+j].get()!="" and "/" in self.liste[self.numero][i]) or (F.saisies[i+j].get() == self.liste[self.numero][i]):
                    message="Correct"
                elif "/" in self.liste[self.numero][i]:
                    message="Correct"
                    v=self.liste[self.numero][i].split("/")
                    if not F.saisies[i+j].get() in v:
                        #
                        c=0
                        r=F.saisies[i+j].get()
                        for n in range(len(v)):
                            if len(r)==len(v[n]):
                                for m in range(len(r)):
                                    if comparaison_caractere(r[m],v[n][m])==False and r[m]!=v[n][m]:
                                        c+=1
                                        break
                            else:
                                c+=1
                        #
                        if c==len(v):
                            message="Incorrect, réponse :\n"
                            t=""
                            for e in self.liste[self.numero][i]:
                                if e=="/":
                                    t+=" ou "
                                else:
                                    t+=e
                            message+=t
                else:
                    #
                    message="Correct"
                    c=True
                    r=F.saisies[i+j].get()
                    if len(r)==len(self.liste[self.numero][i]):
                        for m in range(len(r)):
                            if comparaison_caractere(r[m],self.liste[self.numero][i][m])==False and r[m]!=self.liste[self.numero][i][m]:
                                c=False
                    else:
                        c=False
                    #
                    if c==False:
                        message="Incorrect, réponse :\n"
                        if "/" in self.liste[self.numero][i]:
                            t=""
                            for e in self.liste[self.numero][i]:
                                if e=="/":
                                    t+=" ou "
                                else:
                                    t+=e
                            message+=t
                        else:
                            message+=self.liste[self.numero][i]
                F.reponse.append(Label(F.fenetre,text=message,bg="white"))
                pos=F.saisies[i+j].winfo_rooty()-F.fenetre.winfo_rooty()
                if len(message)>45:
                    F.reponse[-1].place(x=150,y=pos)
                else:
                    F.reponse[-1].place(x=300,y=pos)
                #F.reponse[-1].place(x=300,y=pos)
                rep.append(message)
            else:
                j-=1
        p=1
        self.total+=1
        for r in rep:
            if not "Correct" in r:
                p=0
        self.point+=p
        F.boutons[-1].destroy()
        del self.liste[self.numero]
        del F.boutons[-1]
        try:
            F.boutons[-1].destroy()
            del F.boutons[-1]
        except:
            pass
        if self.liste==[]:
            F.boutons.append(Button(F.fenetre,text="Terminer",command=Lrev.fin))
            F.boutons[-1].place(x=250,y=350,anchor="center")
        elif self.total%20==0:
            F.boutons.append(Button(F.fenetre,text="Terminer",command=Lrev.fin))
            F.boutons[-1].place(x=250,y=380,anchor="center")
            F.boutons.append(Button(F.fenetre,text="Continuer",command=Lrev.question))
            F.boutons[-1].place(x=250,y=350,anchor="center")
        else:
            F.boutons.append(Button(F.fenetre,text="Suivant",command=Lrev.question))
            F.boutons[-1].place(x=250,y=350,anchor="center")
    
    def fin(self):
        while self.reponse!=[]:
            try:
                F.reponse[-1].destroy()
                del F.reponse[-1]
            except:
                break
        message="Score : "+str(self.point)+"/"+str(self.total)
        for i in range(len(self.titre)):
            try:
                if i!=self.choix:
                    F.saisies[-1].destroy()
                    del F.saisies[-1]
                else:
                    F.question.destroy()
                F.nom_saisies[-1].destroy()
                del F.nom_saisies[-1]
            except:
                pass
        F.textes.append(Label(F.fenetre,text=message,bg="white",font=("Calibri",40)))
        F.textes[-1].place(x=250,y=220,anchor="center")
        F.boutons[-1].destroy()
        del F.boutons[-1]
        try:
            F.boutons[-1].destroy()
            del self.liste[self.numero]
            del F.boutons[-1]
        except:
            pass
        F.boutons.append(Button(F.fenetre,text="Recommencer",command=F.recommencer))
        F.boutons[-1].place(x=250,y=350,anchor="center")
        F.boutons.append(Button(F.fenetre,text="Quitter",command=F.fenetre.destroy))
        F.boutons[-1].place(x=250,y=380,anchor="center")

class Creation_fichier:
    def __init__(self):
        self.fichier=""
        self.liste=[]
        self.titre=[]
        self.saisies=[]
        self.nom_colonne=[]
        self.nom_ligne=[]

    def creer(self):
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons[-1].destroy()
        del F.boutons[-1]

        self.ajouter_colonne()
        self.ajouter_colonne()

        F.boutons.append(Button(F.fenetre,text="Ajouter une colonne",command=self.ajouter_colonne))
        F.boutons[-1].place(x=200,y=400,anchor="center")

        F.boutons.append(Button(F.fenetre,text="Suivant",command=self.a_connaitre))
        F.boutons[-1].place(x=400,y=400,anchor="center")

    def a_connaitre(self):
        if len(self.titre)<=1:
            showerror("Loric Révisions - Erreur","Veuillez mettre au moins 2 colonnes.")
            return
        r=askquestion("Loric Révisions","Voulez-vous ajoutez une colonne à connaitre ? (Cette colonne permet de filtrer les lignes importantes)")
        if r=="yes":
            showinfo("Loric Révisions","Dans la colonne à connaitre, mettez oui pour les lignes obligatoire à connaitre et non pour les lignes facultatifs.")
            if len(self.titre)>=5:
                showerror("Loric Révisions - Erreur","Il y a trop de colonnes, impossible de l' ajouter.")
                return
            nom="à connaitre"
            self.titre.append(nom)
            #[F.zone_graphique.create_rectangle(50+len(self.titre)*10,30,100+len(self.titre)*10,70,fill="white"),]
            col=Label(F.fenetre,text=nom,background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8))
            col.place(x=10+len(self.titre)*68,y=180,anchor="nw")
            self.nom_colonne.append(col)
        showinfo("Loric Révisions","Entrer les mots correspondants dans les cases supérieur et cliquez sur Ajouter une ligne. Pour ajouter une réponse multiple, séparer les réponses d'un /")
        self.ajouter_saisies()

    def ajouter_saisies(self):
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons[-1].destroy()
        del F.boutons[-1]
        F.boutons.append(Button(F.fenetre,text="Ajouter une ligne",command=self.ajouter_ligne))
        F.boutons[-1].place(x=200,y=400,anchor="center")
        F.boutons.append(Button(F.fenetre,text="Terminer",command=self.enregistrer))
        F.boutons[-1].place(x=400,y=400,anchor="center")
        for i in range(1,len(self.titre)+1):
            self.saisies.append(Entry(F.fenetre,textvariable=StringVar(),borderwidth=3,relief="solid",width=10))
            self.saisies[-1].place(x=10+i*68,y=150,anchor="nw")

    def ajouter_colonne(self):
        nom=""
        if len(self.titre)>=5:
            showerror("Loric Révisions - Erreur","Il y a trop de colonnes, impossible d'en ajouter une de plus.")
            return
        while nom=="":
            nom=askstring("Loric Révisions","Entrer le nom de votre nouvelle colonne")
            if nom=="":
                showerror("Loric Révisions - Erreur","Veuillez entrer un nom à votre colonne")
            elif nom==None:
                return
            elif self.titre==[]:
                r=askquestion("Loric Révisions","Souhaitez-vous toujours proposer de dévoiler les mots cette colonne et faire deviner les autres (ou le faire au hasard) ?")
                if r=="yes":
                    nom="#"+nom
        self.titre.append(nom)
        #[F.zone_graphique.create_rectangle(50+len(self.titre)*10,30,100+len(self.titre)*10,70,fill="white"),]
        col=Label(F.fenetre,text=nom,background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8))
        col.place(x=10+len(self.titre)*68,y=180,anchor="nw")
        self.nom_colonne.append(col)
        #self.saisies.append()

    def ajouter_ligne(self):
        """
        s=[]
        if len(self.liste)==8:showwarning("Loric Révisions","Il n'y a plus de places à l'écran, mais les lignes continuent à s'ajouter.")
        for i in range(len(self.titre)):
            if self.saisies[i].get()=="":
                showerror("Loric Révisions","Veuillez compléter toutes les cases de la ligne")
                return
        for i in range(len(self.titre)):
            s.append(self.saisies[i].get())
            self.saisies[i].delete(0,END)
            if len(self.liste)==8:
                self.nom_ligne.append(Label(F.fenetre,text="...",background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+8*20,anchor="nw")
            elif len(self.liste)<8:
                self.nom_ligne.append(Label(F.fenetre,text=s[-1],background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+len(self.liste)*20,anchor="nw")
            else:
                m="+"+str(len(self.liste)-7)
                self.nom_ligne.append(Label(F.fenetre,text=m,background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+8*20,anchor="nw")
        self.liste.append(s)
        """
        s=[]
        for i in range(len(self.titre)):
            if self.saisies[i].get()=="":
                showerror("Loric Révisions","Veuillez compléter toutes les cases de la ligne")
                return
        for i in range(len(self.titre)):
            s.append(self.saisies[i].get())
            self.saisies[i].delete(0,END)
            l=len(self.liste)
            while l>8:
                l-=7
            if l==8:
                self.nom_ligne.append(Label(F.fenetre,text="...",background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200,anchor="nw")
                self.nom_ligne.append(Label(F.fenetre,text=s[-1],background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+1*20,anchor="nw")
            elif l<8:
                self.nom_ligne.append(Label(F.fenetre,text=s[-1],background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+l*20,anchor="nw")

            else:
                self.nom_ligne.append(Label(F.fenetre,text=s[-1],background="white",borderwidth=3,relief="solid",width=10,font=("Calibri",8)))
                self.nom_ligne[-1].place(x=10+(1+i)*68,y=200+(len(self.liste)+1)*20,anchor="nw")
        self.liste.append(s)
        

    def enregistrer(self):
        lien=asksaveasfilename(title="Enregistrer votre fiche de révisions",defaultextension="*.lrev",filetypes=(("Fiche de révision lrev","*.lrev"),("Tous les fichiers","*.*")))
        if lien=="":return
        try:
            fichier=open(lien,"w",encoding='utf-8')
            for i in range(len(self.titre)):
                if i==0:
                    mon_titre=self.titre[i]
                else:
                    mon_titre+=","+self.titre[i]
            fichier.write(mon_titre)
            fichier.write("\n")
            while self.liste!=[]:
                ligne2=self.liste.pop(0)
                ligne=""
                for i in range(len(ligne2)):
                    if i!=len(ligne2)-1:
                        ligne+=ligne2[i]+","
                    elif self.liste==[]:
                        ligne+=ligne2[i]
                    else:
                        ligne+=ligne2[i]+"\n"
                fichier.write(ligne)
        except:
            showerror("Loric Révisions - Erreur","Impossible d'enregistrer. Essayez d'enregistrer dans un autre endroit.")
        message="Votre fiche de révision a été enregistrée dans :\n"+str(lien)+"\nMerci d'utiliser Loric Révisions."
        
        try:
            fichier.close()
            showinfo("Loric Révisions - Enregistré",message)
            while self.nom_colonne!=[]:
                self.nom_colonne[-1].destroy()
                del self.nom_colonne[-1]
            while self.nom_ligne!=[]:
                self.nom_ligne[-1].destroy()
                del self.nom_ligne[-1]
            while self.saisies!=[]:
                self.saisies[-1].destroy()
                del self.saisies[-1]
            while F.boutons!=[]:
                F.boutons[-1].destroy()
                del F.boutons[-1]
            accueil(100)
        except:
            pass
            #showerror("Loric Révisions - Erreur","Impossible d'enregistrer. Essayez d'enregistrer dans un autre endroit.")

class Parametre():
    def __init__(self):
        self.fenetre=""
        try:
            self.setting=open("settings.ini","r")
        except:
            self.setting=open("settings.ini","w")

            self.setting.write('couleur="#1B0FFF"\n')

            self.setting.close()
            self.setting=open("settings.ini","r")

        lecture=self.setting.readline()
        self.couleur=lecture[9:16] # #1B0FFF

        self.setting.close()

    def ouverture(self):
        try:
            self.fenetre.destroy()
        except:
            pass
        self.fenetre=Toplevel(F.fenetre)
        geo="503x503+"+str(F.fenetre.winfo_rootx()-8)+"+"+str(F.fenetre.winfo_rooty()-31)
        self.fenetre.geometry(geo)
        self.zone_graphique=Canvas(self.fenetre,width=500,height=500,bg="white")
        self.zone_graphique.grid(row=0,column=0,columnspan=3)
        self.titre=Label(self.fenetre,text="Paramètres",bg="white",font=("Calibri",20))
        self.titre.place(x=40,y=50,anchor="nw")
        self.texte_couleur=Label(self.fenetre,text="Changer la couleur du fond :",bg="white",font=("Calibri",15))
        self.texte_couleur.place(x=40,y=100,anchor="nw")
        self.bouton_couleur=Button(self.fenetre,text="Modifier",command=self.choix_couleur)
        self.bouton_couleur.place(x=300,y=103,anchor="nw")
        self.bouton_couleur=Button(self.fenetre,text="Réinitialiser",command=self.reinitialiser)
        self.bouton_couleur.place(x=40,y=150,anchor="nw")
        self.bouton_couleur=Button(self.fenetre,text="Fermer",command=self.fermeture)
        self.bouton_couleur.place(x=120,y=150,anchor="nw")
        self.bouton_couleur=Button(self.fenetre,text="À propos de nous",command=a_propos)
        self.bouton_couleur.place(x=40,y=200,anchor="nw")
    
    def fermeture(self):
        self.fenetre.destroy()

    def reinitialiser(self):
        self.couleur="#1B0FFF"
        self.enregistrer()
    def enregistrer(self):
        F.zone_graphique.itemconfigure(F.carre,fill=self.couleur)

        self.setting=open("settings.ini","w")

        ecriture='couleur="'+str(self.couleur)+'"\n'
        self.setting.write(ecriture)

        self.setting.close()

    def choix_couleur(self):
        coul=askcolor()
        self.fermeture()
        if coul[1]!=None:
            memoire=self.couleur
            self.couleur=coul[1]
            self.enregistrer()
            r=askquestion("Loric Révision","Est-ce que cette couleur vous convient ?")
            if r=="no":
                self.couleur=memoire
                self.enregistrer()
        self.ouverture()

### Fonctions :
def accueil(n=50):
    if n==0:
        F.zone_graphique.coords(F.rectangle,450,450,50,25)
        F.zone_graphique.coords(F.rectangle,450,450,50,25)
        F.zone_graphique.coords(F.image[-1],250,80)
        F.boutons[-3].place(x=250,y=220,anchor="center")
        F.boutons[-2].place(x=250,y=270,anchor="center")
        F.boutons[-1].place(x=250,y=320,anchor="center")
    elif n==100:
        F.rectangle=F.zone_graphique.create_rectangle(450,450,50,25,fill="white",outline="white")
        F.boutons.append(Button(F.fenetre,text="Ouvrir un fichier de révision",command=Lrev.ouvrir))
        F.boutons[-1].place(x=250,y=220,anchor="center")
        F.boutons.append(Button(F.fenetre,text="Créer un fichier de révision",command=C.creer))
        F.boutons[-1].place(x=250,y=270,anchor="center")
        F.boutons.append(Button(F.fenetre,text="Paramètres",command=Perso.ouverture))
        F.boutons[-1].place(x=250,y=320,anchor="center")
        F.image[0]=ImageTk.PhotoImage(ImageTk.Image.open("titre.png"),master=F.fenetre)
        F.image[1]=F.zone_graphique.create_image(250,80,anchor="center",image=F.image[0])
    else:
        if n==50:
            F.rectangle=F.zone_graphique.create_rectangle(450,-100,50,-100,fill="white",outline="white")
            F.boutons.append(Button(F.fenetre,text="Ouvrir un fichier de révision",command=Lrev.ouvrir))
            F.boutons[-1].place(x=250,y=-220,anchor="center")
            F.boutons.append(Button(F.fenetre,text="Créer un fichier de révision",command=C.creer))
            F.boutons[-1].place(x=250,y=-270,anchor="center")
            F.boutons.append(Button(F.fenetre,text="Paramètres",command=Perso.ouverture))
            F.boutons[-1].place(x=250,y=-320,anchor="center")
            F.image[0]=ImageTk.PhotoImage(ImageTk.Image.open("titre.png"),master=F.fenetre)
            F.image[1]=F.zone_graphique.create_image(250,-280,anchor="center",image=F.image[0])
        else:
            F.zone_graphique.coords(F.rectangle,450,450-n**2,50,25-n**2)
            F.zone_graphique.coords(F.image[-1],250,80-n**2)
            F.boutons[-3].place(x=250,y=220-n**2,anchor="center")
            F.boutons[-2].place(x=250,y=270-n**2,anchor="center")
            F.boutons[-1].place(x=250,y=320-n**2,anchor="center")
        F.fenetre.after(1,lambda:accueil(round(n-0.2, 1)))

def comparaison_caractere(c,r):
    lettres_minuscule=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
    lettres_majuscule=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]
    lettres_a_minuscule="aàâáäã"
    lettres_a_majuscule="AÀÂÁÄÃ"
    lettres_e_minuscule="eèêéë"
    lettres_e_majuscule="EÈÊÉË"
    lettres_i_minuscule="iìîíï"
    lettres_i_majuscule="IÌÎÍÏ"
    lettres_o_minuscule="oòôóöõ"
    lettres_o_majuscule="OÒÔÓÖÕ"
    lettres_u_minuscule="uùûúü"
    lettres_u_majuscule="UÙÛÚÜ"
    lettres_n_minuscule="nñ"
    lettres_n_majuscule="NÑ"
    lettres_c_minuscule="cç"
    lettres_c_majuscule="CÇ"
    espace=" -_',."
    #Lettres majuscules et minuscules
    if r in lettres_minuscule:
        for i in range(len(lettres_minuscule)):
            if lettres_majuscule[i]==c and lettres_minuscule[i]==r:
                return True
    if r in lettres_majuscule:
        for i in range(len(lettres_majuscule)):
            if lettres_minuscule[i]==c and lettres_majuscule[i]==r:
                return True
    #Accents sur le a
    if r in lettres_a_minuscule or r in lettres_a_majuscule:
        if c in lettres_a_minuscule or c in lettres_a_majuscule:
            return True
    #Accents sur le e
    if r in lettres_e_minuscule or r in lettres_e_majuscule:
        if c in lettres_e_minuscule or c in lettres_e_majuscule:
            return True
    #Accents sur le i
    if r in lettres_i_minuscule or r in lettres_i_majuscule:
        if c in lettres_i_minuscule or c in lettres_i_majuscule:
            return True
    #Accents sur le o
    if r in lettres_o_minuscule or r in lettres_o_majuscule:
        if c in lettres_o_minuscule or c in lettres_o_majuscule:
            return True
    #Accents sur le u
    if r in lettres_u_minuscule or r in lettres_u_majuscule:
        if c in lettres_u_minuscule or c in lettres_u_majuscule:
            return True
    #Accents sur le n
    if r in lettres_n_minuscule or r in lettres_n_majuscule:
        if c in lettres_n_minuscule or c in lettres_n_majuscule:
            return True
    #Cédille sur le c
    if r in lettres_c_minuscule or r in lettres_c_majuscule:
        if c in lettres_c_minuscule or c in lettres_c_majuscule:
            return True
    #Séparation
    if r in espace or r in espace:
        if c in espace or c in espace:
            return True
    return False

def a_propos():
    try:
        Perso.fenetre.destroy()
    except:
        pass
    showinfo("Loric Révisions","Loric Révisions :\nCréeateur : Loric Audin\nVersion : 5.0\nCopyright 2022 : Tous droits réservés.")

### Programme principal :
F=Fenetre("Loric Révisions")
try:
    Perso=Parametre()
    F.animation()
except:
    showerror("Loric Révisions - Erreur","Les données personnalisés sont corrompues, nous allons tout réinitialiser.")
    prov=open("settings.ini","w")

    prov.write('couleur="#1B0FFF"\n')

    prov.close()
    Perso=Parametre()
    F.animation()



Lrev=Fichier()
C=Creation_fichier()
F.fenetre.mainloop()
#Projet démarré le 23/01/2022